import java.io.File;

import org.jdom.Document;
import org.jdom.input.JDOMParseException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

import java.io.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

public class XSDValidateAndNormalize {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			
			  if (args.length < 1) {
				  System.out.println("Usage: <progname> <xml doc>");
				  System.exit(-1);
			  }
			
		      SAXBuilder b = new SAXBuilder();
		      b.setFeature ("http://xml.org/sax/features/validation", true);
		      b.setFeature ("http://apache.org/xml/features/validation/schema", true);
		      b.setFeature ("http://apache.org/xml/features/validation/schema-full-checking", true);
		    		      
		      SimpleErrorHandler errorHandler = new SimpleErrorHandler();
		      b.setErrorHandler(errorHandler);
		      Document d = b.build(new File(args[0]));
		      if (!errorHandler.errorOccurred) {
		    	  XMLOutputter outputter = new XMLOutputter();
		    	  outputter.output(d,System.out);
		      }
		    } catch (JDOMParseException e) { 
		    	System.err.println(e.getMessage());
		    } catch (Exception e) { 
		    	e.printStackTrace(); 
		    }
		  }
}